image: docker:latest
services:
  - docker:dind
  
stages:
  - publish
  
variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DEPLOYER_IMAGE: $CI_REGISTRY_IMAGE/deployer

publish:
  stage: publish
  image: node:10
  only:
    - tags
    - master
  script:
    - echo //registry.npmjs.org/:_authToken=$NPM_TOKEN > ~/.npmrc
    - semver
    - sed -i 's|0.0.0-VERSION|'"$VERSION"'|' package.json
    - npm publish --access public

.functions: &functions |
  function semver() {
    if [ -z $CI_BUILD_TAG ]
    then
      echo "No build tag :("
      git describe --tags --abbrev=1
      export VERSION=$(git describe --tags --abbrev=1 | awk -F '-' '{print $1"."$2}' | sed 's|\.$||' | sed 's|\.\.||' )
    else
      echo "WE've got a build tag: " $CI_BUILD_TAG
      export VERSION=$CI_BUILD_TAG
    fi
  }
    
before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com || echo Failed to login to registry.gitlab.com
  - *functions
